import sys, socket, math, traceback
from lovec import *

class Socket:
	__slots__ = ["sock", "buf"]
	
	def __init__(self): self.sock = None; self.buf = ""
	def connect(self, hostName, port):
		try:
			self.sock = socket.socket(socket.AF_INET)
			self.sock.connect((hostName, port))
		except: raise Exception("Prijava na streznik neuspesna")
		self.buf = ""
		server = self.readline()
		print "%s" % server
		self.writeline("AVE %s" % (Lovec.ime))
		succ = self.readline()
		if succ != "PRIJAVA USPESNA": raise Exception("Prijava na streznik neuspesna: %s" % succ)
	def close(self):
		if self.sock: self.sock.close()
	def readline(self):
		while True:
			i = self.buf.find('\n')
			if i >= 0: 
				line = self.buf[:i].strip()
				self.buf = self.buf[i + 1:]
				return line
			try: s = self.sock.recv(1024)
			except: raise Exception("Napaka pri komunikaciji s streznikom")
			if not s: raise Exception("Streznik je zaprl povezavo")
			self.buf += s
	def writeline(self, line): self.sock.send(line + "\n")
	def pojej(self, zakladi, k):
		if k in zakladi:
			zakladi.remove(k)
	def event_loop(self):
		cmda = self.readline().split()
		if cmda[0] == "ADIJO": return False
		if cmda[0] == "KONEC_IGRE": return True
		if cmda[0] != "ZBUDI_SE": raise Exception("Napaka pri komunikaciji s streznikom: %s" % cmda[0])
		
		cmdi = [int(x) for x in cmda[1:]]
		N = cmdi[0]
		K = cmdi[1]
		jaz = Koordinate(*cmdi[2:4])
		nasprotnik = Koordinate(*cmdi[4:6])
		zakladi = [Koordinate(*cmdi[i:i+2]) for i in range(6,6+2*K,2)]
		
		t = Lovec()
		t.ZbudiSe(N, K, jaz, nasprotnik, zakladi)
		
		self.writeline("BUDEN")
		
		while True:
			cmda = self.readline().split()
			if cmda[0] == "ADIJO": return False
			elif cmda[0] == "KONEC_IGRE":
				t.KonecIgre(); break
			elif cmda[0] == "QV":
				kj = Koordinate(*map(int, cmda[1:3]))
				kn = Koordinate(*map(int, cmda[3:5]))
				self.pojej(zakladi,kj)
				self.pojej(zakladi,kn)
				(dx,dy) = t.KamGres(kj, kn, zakladi)
				self.writeline("QVR %d %d" % (dx,dy))
			else: raise Exception("Napaka pri komunikaciji s streznikom: %s" % cmda[0])
		return True

if len(sys.argv) > 1: hostName = sys.argv[1]
else: hostName = "localhost"

try:
	sock = Socket()
	sock.connect(hostName, 1175)
	while sock.event_loop(): pass
	sock.close()
except:
	traceback.print_exc()
